####################################################################################################
#			Trial Script
#Requirements: Working verison of SSA (tssite ginfo is needed), RaidenFTPD
# Pretty much what this thing does is uses the tssite ginfo command for the "Trial" group.
# It goes through each name in the group and then:
#	1. Parses the shit from raiden and extracts a Username and amount they uploaded.
#	2. Searches for a textfile for that user (i.e. username.txt), if a file isnt found it creates one and puts the current date in it.
#	3. Reads the text file for that user and compares the date stored in it to the current one. 
#	4. Once the certain amount of days pass by, it checks to see if they uploaded the required amount. if they dont, they get the axe.
#	5. If the user does pass after the required amount of days, their group is changed to a default one.


#	Usage: !blahtrials :returns the list of people on trial.
#	       !blahtrials <username> :returns trial status on a specific user.
#	       !blahtrials script :returns info on the script
#	       !blahtrials help   :returns help dialog
####################################################################################################
proc u {} {return };	# underline code
proc r {} {return };	# reverse code
proc b {} {return };	# bold code
proc c {} {return };	# color code
proc o {} {return };	# reset attributes code
#------------------- START CONFIGURATION BELOW THIS LINE-----------------------------------

#Choose the amount of days you would like the trial to last
set tssite(days) "7"

#Set the required amount in MB that needs to be uploaded.
set tssite(mb) "2048"

#set the group you would like the users on trial changed to if they pass.
set tssite(newgroup) "iND"

#Set the name of the site
set tssite(name) "Your-Site-Name"

#set the name of the channel you would like the bot to message
set tssite(chan) "#Your-Site-Chan"

#your sites command stem. example-> !blahtrials list <- most people use an abbreviation of their sitename
set tssite(cmdpre) "!blahtrials"; 

#set the color you would like to use for the bots messages to the channel, like a color theme. hit ctrl + k in mirc to see the list.
set tssite(color) "7"

### NEW IN VERSION 2.0 -dont forget to config these! ####
#this may be the most important variable to set. READ CAREFULLY!
#set the file path to your raidenftpd .user file (its in the raiden directory)
#make sure the slashes look like / instead of \
#Example: D:/Program Files/RaidenFTPD/default.user 

set tssite(userfile) "C:/Program Files/RaidenFTPD/default.user"

#set the group that you would added all the trial users to
set tssite(group) "trial"

#set the usernames of the super accounts to be excluded
set tssite(super) "halcy0n"

# set the directory to store the trial userfiles  
# (THIS DIRECTORY HAS TO BE MADE IN THE WINDROP/EGGDROP DIRECTORY BEFORE USE)
# The default is trialusers so you should make a directory called trialusers in your windrop/eggdrop directory.
set tssite(userdir) "trialusers"

#What do you want the script to do to users that fail the trial?
# set tssite(delete) 0   <-- if you set it like this, it will AUTODELETE them
# set tssite(delete) 1   <-- if you set it like this, it will not delete them, but it will make an announcement that they failed.
# set tssite(delete) 2   <-- if you set it like this, it will AUTOSUSPEND them
set tssite(delete) 0

#------------------ END CONFIGURATION ---------------------------------
#I am not responsable for what happens if you edit below this line. 

set script(name) "TRiAL-SCRiPT"
set script(ver)  "2.4"
set script(pimp) "halcy0n"

bind pub - [set tssite(cmdpre)] tsmain

proc tsmain {nick uhost hand chan args} {
set args [lindex $args 0]
      switch [string tolower $args] {
	script { 
	   tadvertise
	} help { 
	   trialhelp
	} default {
	    if {[string length $args] > 2} {
	     searchtrial $args
	    } else {
	     passed
            }
        }
       }
return
}

proc passed { } {
global tssite
putlog "passed"
 set validfound 0
 set chanmsg "[c]$tssite(color)([c][b]$tssite(name)[b][c]$tssite(color))[c][b]-TRiALS-[b]"
 set fileid [open $tssite(userfile) r]
 set ruserfile [read $fileid]
 close $fileid
 set ruserfile [split $ruserfile \n]
    foreach line $ruserfile {
     	if {$line != ""} {
   		set fields [split $line :]
    		if {[string toupper [lindex $fields 3]] == [string toupper $tssite(group)]} {
	     	   set userupload [expr [lindex $fields 11] / 1024]
	     	   set usergroup [lindex $fields 3]
	     	   set userlogin [lindex $fields 0]
	     	    if {[file exists $tssite(userdir)/$userlogin.txt]} {
	     		set olduserfile [open "$tssite(userdir)/$userlogin.txt" r]
	      	        set dateadded [read $olduserfile]
	      		close $olduserfile
	      		set dayson [tcheckdate $dateadded]
	      		   if {[checker $userlogin $dayson $userupload] == "Passed"} {
				putlog "appending $userlogin"
		    	set chanmsg [lappend chanmsg "[c]$tssite(color)$userlogin:([c][b]Day:$dayson/$tssite(days)-$userupload/$tssite(mb)mb[b][c]$tssite(color))[c]"]
	        	    }
		   	incr validfound 1
		   	putlog $validfound
	            } else {
	      		set newuserfile [open $tssite(userdir)/$userlogin.txt a+]
	      		set now [clock seconds]
	      		set fmt "%Y-%m-%d"
	      		set now [clock format $now -format $fmt]
	      		puts $newuserfile $now
	      		close $newuserfile
	      		incr validfound 1
	      		set dayson 0
	      		set chanmsg [lappend chanmsg "[c]$tssite(color)$userlogin:([c][b]Day:$dayson/$tssite(days)-$userupload/$tssite(mb)mb[b][c]$tssite(color))[c]"]
	      	    }
	         } 
         }
    }
#foreach end ^^
	putlog $chanmsg
    	set chanmsg [split $chanmsg ]
	putlog [llength $chanmsg ]
	 if {[llength $chanmsg] > 0 && [llength $chanmsg] < 10} {
	    putserv "PRIVMSG $tssite(chan) :[join [lrange $chanmsg 0 9] ]"
	    return 0
	 }
	 if {[llength $chanmsg] > 9 && [llength $chanmsg] < 20} {
	    putserv "PRIVMSG $tssite(chan) :[join [lrange $chanmsg 0 9] ]"
	    putserv "PRIVMSG $tssite(chan) :[join [lrange $chanmsg 10 19] ]"
	    return 0
	 }
	 if {[llength $chanmsg] > 19 && [llength $chanmsg] < 29} {
	    putserv "PRIVMSG $tssite(chan) :[join [lrange $chanmsg 0 9] ]"
	    putserv "PRIVMSG $tssite(chan) :[join [lrange $chanmsg 10 19] ]"
	    putserv "PRIVMSG $tssite(chan) :[join [lrange $chanmsg 20 29] ]"
	    return 0
	 }
   return 0
}


proc checker {nick days upload} {
global tssite
if ![info exists upload] {set upload 0}
putlog "in the checker"
if {$days == $tssite(days) || $days > $tssite(days)} {
   if {$upload < $tssite(mb)} {
	putlog "im in deluser"
	switch $tssite(delete) {
	  0 { set resp [FTP::Quote site deluser $nick]
              putserv "PRIVMSG $tssite(chan) :[c]$tssite(color)([c][b]$tssite(name)[b][c]$tssite(color))[c] [b]- AUTOdELETE - $nick[b] has [b]FAILED[b] trial. Goodbye."
	      set filename [concat $nick.txt]
	      set deleteit [file delete $filename]
           } 1 { putserv "PRIVMSG $tssite(chan) :[c]$tssite(color)([c][b]$tssite(name)[b][c]$tssite(color))[c] [b]- FAILED - $nick[b] has [b]FAILED[b] trial."
           } 2 {    set resp [FTP::Quote site disable $nick]
		putserv "PRIVMSG $tssite(chan) :[c]$tssite(color)([c][b]$tssite(name)[b][c]$tssite(color))[c] [b]- AUTOsUSPEND - $nick[b] has [b]FAILED[b] trial." 
		set filename [concat $nick.txt]
	      set deleteit [file delete $filename]
       	 }   
	}
	set result "Failed"
   }
}
if ![info exists upload] {set upload 0}
   if {$upload > $tssite(mb)} {
	putlog "im in chgrp"
putserv "PRIVMSG $tssite(chan) :[c]$tssite(color)([c][b]$tssite(name)[b][c]$tssite(color))[c] [b]- PASSED - $nick[b] has [b]PASSED[b] and was moved trial! Good Job."
	set resp [FTP::Quote site chgrp $nick $tssite(newgroup)]
	set result "Passed"	
   } else {
	set result "Passed"
}

return $result
}

proc searchtrial {search} {
global tssite
putlog "search"
 set validfound 0
 set chanmsg "[c]$tssite(color)([c][b]$tssite(name)[b][c]$tssite(color))[c] [b]- TRiALS -[b]"
 set fileid [open $tssite(userfile) r]
 set ruserfile [read $fileid]
 close $fileid
 set ruserfile [split $ruserfile \n]
 foreach line $ruserfile {
  if {$line != ""} {
   set fields [split $line :]
    if {[string toupper [lindex $fields 3]] == [string toupper $tssite(group)]} {
     if {[string toupper $search] == [string toupper [lindex $fields 0]]} {
     set userupload [expr [lindex $fields 11] / 1024]
     set usergroup [lindex $fields 3]
     set userlogin [lindex $fields 0]
     set userratio [lindex $fields 7]
     if {[file exists $tssite(userdir)/$userlogin.txt]} {
      set olduserfile [open "$tssite(userdir)/$userlogin.txt" r]
      set dateadded [read $olduserfile]
      close $olduserfile
      set dayson [tcheckdate $dateadded]
      if {[lsearch $tssite(super) $search] || $userratio == 0} {
      putserv "PRIVMSG $tssite(chan) :$chanmsg [b]$search[b] is not up for trial."
      break
      }
      putserv "PRIVMSG $tssite(chan) :$chanmsg [b]$search[b] is up for trial, and he better upload [b][concat [expr $tssite(mb) - $userupload]MB][b] in [b][expr $tssite(days) - $dayson] days[b] or else he's gonna get the boot."
      set validfound 1
      checker $userlogin $dayson $userupload
      break
    }
    }
   }
  }
 }
 if {$validfound != 1} { 
  putserv "PRIVMSG $tssite(chan) :$chanmsg There is nobody on trial with that login." 
 }
return 0
}
proc trialhelp {} {
putlog "help" 
global tssite
putserv "PRIVMSG $tssite(chan) :[c]$tssite(color)([c][b]$tssite(name)[b][c]$tssite(color))[c] to see a list of trial accounts use $tssite(cmdpre), to see info on a specific user type $tssite(cmdpre) (username)."
}


proc tcheckdate {dateadded} {
global tssite
putlog "check"
	set now [clock seconds]
	set added [clock scan $dateadded]
	set difference [expr $now - $added]
	set tminutes [expr $difference / 60]
	set thours [expr $tminutes / 60]
	set tdays [expr $thours / 24]
return "$tdays"
}


proc tadvertise {} {
global tssite script
putserv "PRIVMSG $tssite(chan) :[c]$tssite(color)[b]$script(name)[c] $script(ver)[b] By: [c]$tssite(color)[b]$script(pimp)[b][c] - [b]http://halcy0n.no-ip.org[b]"
}
